local bar = _G[...]
local modName = ...

local name, frame = "timer", PetBattleFrame.BottomFrame.TurnTimer

local component = bar:NewComponent(name, 'Frame')

function component:New(parent)
	local name = ('%s_'..name):format(modName)
	if _G[name] then
		return _G[name]
	end
	local bar = self:Bind(frame)
	bar.owner = parent
	bar:SetParent(parent.header)
--	bar:SetMovable(true)
--	bar:SetUserPlaced(true)
	bar:Show()
	bar:ClearAllPoints()
	
	return bar
end

component.defaults = {
	scale = 100,
	position = 3,
	padding = 0,
	enable = true,
	alpha = 100,
}

function component:Layout()
	local sets = self.sets
	if sets.enable ~= true then
		self:Hide()
		self.noUpdate = true
		return
	else
		self:Show()
		self.noUpdate = nil
	end
	local sets = self.sets
	self:Reposition()
	self:Rescale()
	
	self:SetAlpha(sets.alpha/100)
end

function component:Rescale()
	self:SetScale(self.sets.scale/100)
end

local points  = {
	"Top",
	"Right",
	"Bottom",
	"Left",
}

function component:Reposition()
	self:ClearAllPoints()
	
	
	local position = self.sets.position
	local pad = self.sets.padding--/(self.sets.scale/100)
	local anchor = points[position]

	
	local w, h = frame:GetSize()
	self.w, self.h = self.w or w, self.h or h
	self:SetSize(self.w, self.h)	

	local x = 0
	local y = 0
	local z = 28
	
	if position == 1 then
		x = 0
		y = pad + z
	elseif position == 2 then
		x = pad + self.w - 30
		y = 0
	elseif position == 3 then
		x = 0
		y = -pad - z
	elseif position == 4 then
		x = -pad - self.w - 8
		y = 0
	end
	
	self:SetPoint(anchor, self:GetParent(), anchor, x, y)
end

local options = {
		{
			name = 'Opacity',
			kind = 'Slider',
			key = 'alpha',
			min = 0,
			max = 100,
			panel = "basic",
		},    

        {
            name = 'Padding',
            kind = 'Slider',
            key = 'padding',
            min = -400,
            max = 400,
		panel = "basic",
        },
        {
            name = 'Position',
            kind = 'Slider',
            key = 'position',
            min = 1,
            max = 4,
		panel = "basic",
        },
        {
            name = 'Scale',
            kind = 'Slider',
            key = 'scale',
            min = 25,
            max = 250,
		panel = "basic",
        },
	
}


function component:CreateMenu(menu)
	return bar.Menu.NewMenu(self, menu, name, options)
end