local bar = _G[...]
local modName = ...
local L
local NAME = 1
local function Menu(menu, name, key, table, sub)
	local f = CreateFrame('Frame', NAME..name, menu)
	NAME = NAME + 1
	f:SetSize(24, 24)
	f.button = CreateFrame('Button', f:GetName()..'Button', f)
	f.dumb = CreateFrame('Frame', nil, f)
	f.dumb:SetSize(24, 24)
	f.dumb:SetPoint('TopLeft')
	f.button:SetSize(24, 24)
	f.button:SetNormalTexture('Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Up')
	f.button:SetPushedTexture('Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Down')
	f.button:SetDisabledTexture('Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Disabled')
	f.button:SetHighlightTexture('Interface\\Buttons\\UI-Common-MouseHilight')
	f.text = f:CreateFontString(f:GetName() .. 'Text', 'OVERLAY', 'GameFontHighlightSmall')
	f.text:SetPoint('BottomLeft', f.button, 'BottomRight', 6, 2)
	f.text:SetJustifyH('LEFT')
	local title = f:CreateFontString(nil, 'OVERLAY', 'GameFontNormalSmall')
	title:SetPoint('TopLeft', f.button, 'TopRight', 4, -2)
	title:SetText(name)
	f.title = title

	f:SetScript('OnHide', function() CloseDropDownMenus() end)
	f.button:SetScript('OnClick', function(self)
		UIDropDownMenu_SetAnchor(f, -4, 6, 'TopLeft', f.button, 'BottomLeft')
		ToggleDropDownMenu(1, 1, f)
		PlaySound('igMainMenuOptionCheckBoxOn')
	end)

	local dropDownList = _G['DropDownList'..1]
	dropDownList.dropdown = f
	dropDownList.shouldRefresh = true
	
	
	if sub then
		f.button:SetPoint('Top', 10, 0)
	else
		f.button:SetPoint('Top')
	end
	
	local prev = menu.lastWidget
	if prev then
		f:SetPoint('TOPLEFT', prev, 'BOTTOMLEFT', 0, -0)
	else
		f:SetPoint('TOPLEFT', 2, -5)
	end
	f.point = {f:GetPoint()}
	menu.lastWidget = f.dumb
	f.button:SetHitRectInsets(0, 0 , 0, 0)
	menu.height = menu.height + 24
	return f
end

local blackList = {
	point = 1,
	x = 1,
	y = 1,
	anchor = 1,
}

local function Copy(source, destination, looped)
	if not destination then
		destination = {}
	end
	for i, b in pairs(CopyTable(source)) do
		if (type(b) == 'table') then
			destination[i] = Copy(b, destination[i], true)
		else
			if (not looped) and (blackList[i]) then
				
			else
				destination[i] = b
			end
		end
	end
	return destination
end


do --Copy functions
    local Base = {
        defaults = {
            focus = {
                scale = .75,
                showInOverrideUI = false,
                showInPetBattleUI = false,
                anchor  = 'playerBR',
                point = 'Center',
                padW = 3,
                width = 232,
                y = 0,
                x = 0,
                padH = 3,
                height = 100,
            },
            targettarget = {
                scale = .75,
                showInOverrideUI = false,
                showInPetBattleUI = false,
                anchor  = 'targetRB',
                point = 'Center',
                padW = 3,
                width = 232,
                y = 0,
                x = 420,
                padH = 3,
                height = 100,
            },
            target = {
                scale = 1,
                showInOverrideUI = false,
                showInPetBattleUI = false,
                point = 'TopLeft',
                padW = 3,
                width = 232,
                y = 0,
                x = 235,
                padH = 3,
                height = 100,
                debuffs = {
                    columns = 6,
                    scale = 76,
                    color = {
                        a = 1,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    rows = 3,
                    isLeftToRight = true,
                    x = 0,
                    y = -73,
                    isTopToBottom = true,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "Top",
                    enable = true,
                    showBG = false,
                    alpha = 100,
                },
                buffs = {
                    columns = 6,
                    color = {
                        a = 1,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    scale = 64,
                    rows = 1,
                    isLeftToRight = true,
                    isTopToBottom = false,
                    y = 6,
                    x = 12,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomLeft",
                    enable = true,
                    showBG = false,
                    alpha = 100,
                },

            },
            player = {
                scale = 1,
                showInOverrideUI = false,
                showInPetBattleUI = false,
                point = 'TopLeft',
                padW = 3,
                width = 232,
                y = 0,
                x = 0,
                padH = 3,
                height = 100,
                overlay = {
                    enable = true,
                },
                debuffs = {
                    columns = 6,
                    isLeftToRight = true,
                    color = {
                        a = 1,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                    rows = 3,
                    alpha = 100,
                    isTopToBottom = true,
                    y = -73,
                    x = 0,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "Top",
                    enable = false,
                    showBG = false,
                    scale = 76,
                },
                cast = {
                    textY = 0,
                    enable = true,
                    textheight = 12,
                    Sparkarc = 0,
                    sparkY = 0,
                    anchor = "Left",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    showBG = false,
                    CurveOffset = 0,
                    yTextOffset = 0,
                    xTextOffset = 0,
                    frameLevel = 2,
                    frameLayer = 4,
                    textX = 0,
                    maxTextWidth = 98,
                    alpha = 100,
                    width = 117,
                    y = 17,
                    x = 225,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 16,
                    anchorText = "Center",
                    scale = 100,
                    textureName = "Blizzard",
                },
                focus = {
                    y = -12,
                    x = 42,
                    mouseOverTooltip = true,
                    enable = true,
                    anchor = "TopLeft",
                    scale = 95,
                    alpha = 100,
                    usePortrait = true,
                },
                level = {
                    scale = 100,
                    justifyV = 1,
                    width = 25,
                    y = -16,
                    x = -63,
                    justifyH = 2,
                    anchor = "Center",
                    enable = true,
                    height = 12,
                },
                threat = {
                    scale = 100,
                    justifyV = 1,
                    width = 35,
                    y = 12,
                    x = 0,
                    justifyH = 3,
                    height = 12,
                    enable = true,
                    anchor = "top",
                },
                background = {
                    edgeSize = 13,
                    inset = 0,
                    color = {
                        a = 0.5,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                    enable = true,
                    bgPad = 0,
                    edgecolor = {
                        a = 100,
                        r = 100,
                        g = 100,
                        b = 100,
                    },
                    textureName = "Blizzard Tooltip",
                    y = -26,
                    x = 111,
                    width = 51,
                    edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
                    anchor = "TopLeft",
                    height = 41,
                    texturePath = "Interface\\Tooltips\\UI-Tooltip-Background",
                    scale = 100,
                },
                power = {
                    maxTextWidth = 300,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    enable = true,
                    yTextOffset = 0,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopLeft",
                    format = "percent",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    textY = 0,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textVert = 2,
                    textHori = 2,
                    alpha = 100,
                    textX = 0,
                    mouseover = "value",
                    width = 116,
                    y = -52,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 12,
                    anchorText = "Center",
                    percent = true,
                    x = 109,
                },
                icons = {
                    frameLayer = 3,
                    enable = true,
                    columns = 8,
                    compress = 0,
                    scale = 130,
                    alpha = 100,
                    IsLeftToRight = false,
                    width = 45,
                    y = 2,
                    IsTopToBottom = true,
                    style = "ROUND",
                    spacing = 0,
                    height = 45,
                    angle = 227,
                    x = 45,
                    anchor = "Left",
                },
                health = {
                    textY = 0,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    classColor = false,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopLeft",
                    format = "value",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    enable = true,
                    orient = "HORIZONTAL",
                    maxTextWidth = 300,
                    textVert = 2,
                    textX = 0,
                    textHori = 2,
                    alpha = 100,
                    mouseover = "value",
                    width = 115,
                    y = -41,
                    x = 110,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 12,
                    anchorText = "Center",
                    percent = true,
                    CurveOffset = 0,
                },
                model = {
                    zoom = 0,
                    frameLevel = 1,
                    frameLayer = 1,
                    scale = 1,
                    justifyV = "CENTER",
                    width = 133,
                    y = -45,
                    x = -110,
                    justifyH = "CENTER",
                    rotation = 0,
                    anchor = "BottomLeft",
                    height = 197,
                    enable = false,
                    clickThru = true,
                },
                buffs = {
                    columns = 6,
                    isLeftToRight = true,
                    scale = 64,
                    rows = 1,
                    alpha = 100,
                    x = 94,
                    y = 7,
                    isTopToBottom = false,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomLeft",
                    enable = false,
                    showBG = false,
                    color = {
                        a = 1,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                },
                name = {
                    enable = true,
                    justifyV = 1,
                    width = 100,
                    y = 19,
                    x = 50,
                    justifyH = 2,
                    height = 12,
                    scale = 100,
                    anchor = "Center",
                },
            },
            focustarget = {
                scale = .7,
                showInOverrideUI = false,
                showInPetBattleUI = false,
                anchor  = 'focusRB',
                point = 'Center',
                padW = 3,
                width = 232,
                y = 0,
                x = 0,
                padH = 3,
                height = 100,
            },
            playerpet = {
                scale = .75,
                showInOverrideUI = false,
                showInPetBattleUI = false,
                anchor  = 'focusBL',
                point = 'Center',
                padW = 3,
                width = 232,
                y = 0,
                x = 0,
                padH = 3,
                height = 100,
            },
	vehicle = {
		scale = .75,
		showInOverrideUI = false,
		showInPetBattleUI = false,
		anchor  = 'focusBL',
		point = 'Center',
		padW = 3,
		width = 232,
		y = 0,
		x = 0,
		padH = 3,
		height = 100,
	},

			},
        author = {
            boss1 = {
                overlay = {
                    enable = false,
                },
                debuffs = {
                    columns = 7,
                    alpha = 100,
                    color = {
                        a = 1,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                    rows = 2,
                    isLeftToRight = true,
                    isTopToBottom = false,
                    y = 47,
                    x = 354,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomRight",
                    enable = false,
                    showBG = false,
                    scale = 77,
                },
                scale = 1,
                Class = {
                    textY = 0,
                    prevOrient = "HORIZONTAL",
                    enable = true,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopRight",
                    format = "value",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    orient = "HORIZONTAL",
                    textX = 0,
                    textVert = 2,
                    alpha = 100,
                    width = 51,
                    y = -41,
                    x = -106,
                    mouseover = "value",
                    textHori = 2,
                    height = 12,
                    anchorText = "Center",
                    percent = true,
                    scale = 100,
                },
                cast = {
                    maxTextWidth = 98,
                    scale = 100,
                    multi = true,
                    showBG = false,
                    textureName = "Blizzard",
                    sparkY = 0,
                    Sparkarc = 0,
                    textY = 0,
                    arcMid = 0,
                    anchor = "Right",
                    arcEnd = 0,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    frameLevel = 2,
                    x = -1,
                    textAnchor = "Center",
                    textX = 0,
                    frameLayer = 4,
                    yTextOffset = 0,
                    xTextOffset = 0,
                    alpha = 100,
                    width = 122,
                    y = 0,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 22,
                    anchorText = "Center",
                    enable = true,
                    textheight = 12,
                },
                focus = {
                    y = 0,
                    x = -2,
                    mouseOverTooltip = true,
                    enable = true,
                    anchor = "Left",
                    scale = 86,
                    alpha = 100,
                    usePortrait = true,
                },
                level = {
                    scale = 100,
                    justifyV = 2,
                    width = 25,
                    y = 0,
                    x = 0,
                    justifyH = 2,
                    height = 26,
                    anchor = "Right",
                    enable = true,
                },
                showInPetBattleUI = false,
                threat = {
                    scale = 100,
                    justifyV = 1,
                    width = 35,
                    y = 12,
                    x = 0,
                    justifyH = 3,
                    height = 12,
                    enable = true,
                    anchor = "top",
                },
                power = {
                    maxTextWidth = 98,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    format = "percent",
                    justifyV = "CENTER",
                    textureName = "Raid",
                    textY = 0,
                    textVert = 2,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "BottomRight",
                    arcEnd = 0,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    height = 12,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textX = 0,
                    alpha = 100,
                    CurveOffset = 0,
                    y = -1,
                    mouseover = "value",
                    width = 124,
                    yTextOffset = 0,
                    x = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    enable = true,
                },
                showInOverrideUI = false,
                icons = {
                    enable = true,
                    spacing = 0,
                    anchor = "Left",
                    angle = 46,
                    IsLeftToRight = false,
                    columns = 8,
                    compress = 0,
                    IsTopToBottom = true,
                    frameLayer = 4,
                    isLeftToRight = true,
                    width = 55,
                    y = 0,
                    x = 0,
                    style = "SQUARE",
                    reverse = true,
                    height = 55,
                    scale = 78,
                    isTopToBottom = false,
                    alpha = 100,
                },
                width = 173,
                background = {
                    edgeSize = 13,
                    color = {
                        a = 0.5,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                    inset = 0,
                    scale = 100,
                    bgPad = 0,
                    x = 0,
                    textureName = "Blizzard Tooltip",
                    y = 0,
                    edgecolor = {
                        a = 100,
                        r = 100,
                        g = 100,
                        b = 100,
                    },
                    anchor = "Right",
                    edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
                    height = 51,
                    width = 91,
                    texturePath = "Interface\\Tooltips\\UI-Tooltip-Background",
                    enable = true,
                },
                health = {
                    textY = 0,
                    arcEnd = 0,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    enable = true,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    maxTextWidth = 98,
                    height = 12,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopRight",
                    format = "percent",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    textX = 0,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textVert = 2,
                    x = 0,
                    yTextOffset = 0,
                    mouseover = "current",
                    alpha = 100,
                    width = 124,
                    y = 0,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    arcMid = 0,
                },
                model = {
                    zoom = 0,
                    frameLevel = 1,
                    frameLayer = 1,
                    scale = 1,
                    justifyV = "CENTER",
                    width = 133,
                    y = -45,
                    x = -110,
                    justifyH = "CENTER",
                    rotation = 0,
                    anchor = "BottomLeft",
                    height = 197,
                    enable = false,
                    clickThru = true,
                },
                height = 47,
                buffs = {
                    columns = 7,
                    alpha = 100,
                    scale = 77,
                    rows = 2,
                    isLeftToRight = true,
                    x = 2,
                    y = 48,
                    isTopToBottom = false,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomLeft",
                    enable = false,
                    showBG = false,
                    color = {
                        a = 1,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                },
                class = {
                    scale = 100,
                    alpha = 100,
                    width = 51,
                    y = -51,
                    x = 0,
                    drop = true,
                    height = 12,
                    enable = true,
                    anchor = "BottomRight",
                },
                name = {
                    enable = true,
                    justifyV = 2,
                    width = 98,
                    y = 0,
                    x = 51,
                    justifyH = 1,
                    anchor = "Left",
                    height = 26,
                    scale = 100,
                },
            },
            focustarget = {
                overlay = {
                    enable = false,
                },
                debuffs = {
                    columns = 7,
                    scale = 77,
                    color = {
                        a = 1,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    rows = 2,
                    alpha = 100,
                    isTopToBottom = false,
                    y = 47,
                    x = -354,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomLeft",
                    enable = false,
                    showBG = false,
                    isLeftToRight = true,
                },
                scale = 1.02,
                Class = {
                    textY = 0,
                    prevOrient = "HORIZONTAL",
                    enable = true,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopLeft",
                    format = "value",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    orient = "HORIZONTAL",
                    textVert = 2,
                    scale = 100,
                    alpha = 100,
                    width = 51,
                    y = -41,
                    x = 106,
                    mouseover = "value",
                    height = 12,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    textX = 0,
                },
                cast = {
                    maxTextWidth = 98,
                    enable = true,
                    multi = true,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    sparkY = 0,
                    scale = 100,
                    Sparkarc = 0,
                    textY = 0,
                    arcMid = 0,
                    anchor = "Left",
                    arcEnd = 0,
                    showBG = false,
                    frameLevel = 2,
                    x = 1,
                    textAnchor = "Center",
                    textX = 0,
                    frameLayer = 4,
                    yTextOffset = 0,
                    xTextOffset = 0,
                    alpha = 100,
                    width = 122,
                    y = 0,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 22,
                    anchorText = "Center",
                    textureName = "Blizzard",
                    textheight = 12,
                },
                focus = {
                    y = 0,
                    usePortrait = true,
                    mouseOverTooltip = true,
                    x = 2,
                    enable = true,
                    scale = 86,
                    alpha = 100,
                    anchor = "Right",
                },
                level = {
                    scale = 100,
                    justifyV = 2,
                    width = 25,
                    y = 0,
                    x = 0,
                    justifyH = 2,
                    height = 26,
                    enable = true,
                    anchor = "Left",
                },
                showInPetBattleUI = false,
                threat = {
                    scale = 100,
                    justifyV = 1,
                    width = 35,
                    y = 12,
                    x = 0,
                    justifyH = 1,
                    height = 12,
                    anchor = "top",
                    enable = true,
                },
                power = {
                    maxTextWidth = 98,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    format = "percent",
                    justifyV = "CENTER",
                    textureName = "Raid",
                    textY = 0,
                    textX = 0,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "BottomLeft",
                    arcEnd = 0,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    textHori = 2,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textVert = 2,
                    alpha = 100,
                    CurveOffset = 0,
                    y = -1,
                    mouseover = "value",
                    width = 124,
                    yTextOffset = 0,
                    x = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 12,
                    anchorText = "Center",
                    percent = true,
                    enable = true,
                },
                showInOverrideUI = false,
                icons = {
                    enable = true,
                    spacing = 0,
                    anchor = "Right",
                    angle = 46,
                    isLeftToRight = false,
                    columns = 8,
                    compress = 0,
                    IsLeftToRight = false,
                    scale = 78,
                    alpha = 100,
                    width = 55,
                    y = 0,
                    isTopToBottom = false,
                    style = "SQUARE",
                    reverse = true,
                    height = 55,
                    frameLayer = 4,
                    IsTopToBottom = true,
                    x = 0,
                },
                width = 173,
                class = {
                    scale = 100,
                    alpha = 100,
                    width = 51,
                    y = -51,
                    x = 0,
                    drop = true,
                    height = 12,
                    anchor = "BottomLeft",
                    enable = true,
                },
                health = {
                    textY = 0,
                    arcEnd = 0,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    enable = true,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    maxTextWidth = 98,
                    textHori = 2,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopLeft",
                    format = "percent",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    textVert = 2,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textX = 0,
                    x = 0,
                    yTextOffset = 0,
                    alpha = 100,
                    mouseover = "current",
                    width = 124,
                    y = 0,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 12,
                    anchorText = "Center",
                    percent = true,
                    arcMid = 0,
                },
                model = {
                    zoom = 0,
                    frameLevel = 1,
                    frameLayer = 1,
                    scale = 1,
                    justifyV = "CENTER",
                    width = 133,
                    y = -45,
                    x = 110,
                    justifyH = "CENTER",
                    clickThru = true,
                    anchor = "BottomRight",
                    enable = false,
                    height = 197,
                    rotation = 0,
                },
                height = 47,
                buffs = {
                    columns = 7,
                    color = {
                        a = 1,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    scale = 77,
                    rows = 2,
                    alpha = 100,
                    x = -2,
                    y = 48,
                    isTopToBottom = false,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomRight",
                    enable = false,
                    showBG = false,
                    isLeftToRight = true,
                },
                name = {
                    enable = true,
                    justifyV = 2,
                    width = 98,
                    y = 0,
                    x = -51,
                    justifyH = 3,
                    anchor = "Right",
                    scale = 100,
                    height = 26,
                },
                background = {
                    edgeSize = 13,
                    color = {
                        a = 0.5,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    texturePath = "Interface\\Tooltips\\UI-Tooltip-Background",
                    enable = true,
                    bgPad = 0,
                    width = 91,
                    textureName = "Blizzard Tooltip",
                    y = 0,
                    x = 0,
                    height = 51,
                    edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
                    anchor = "Left",
                    edgecolor = {
                        a = 100,
                        b = 100,
                        g = 100,
                        r = 100,
                    },
                    inset = 0,
                    scale = 100,
                },
            },
            targettarget = {
                overlay = {
                    enable = false,
                },
                debuffs = {
                    columns = 7,
                    scale = 77,
                    color = {
                        a = 1,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    rows = 2,
                    alpha = 100,
                    isTopToBottom = false,
                    y = 47,
                    x = -354,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomLeft",
                    enable = false,
                    showBG = false,
                    isLeftToRight = true,
                },
                scale = 1,
                class = {
                    scale = 100,
                    alpha = 100,
                    width = 51,
                    y = -51,
                    x = 0,
                    drop = true,
                    height = 12,
                    anchor = "BottomLeft",
                    enable = true,
                },
                padW = 1,
                focus = {
                    y = 0,
                    usePortrait = true,
                    mouseOverTooltip = true,
                    x = 2,
                    enable = true,
                    scale = 86,
                    alpha = 100,
                    anchor = "Right",
                },
                background = {
                    edgeSize = 13,
                    color = {
                        a = 0.5,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    texturePath = "Interface\\Tooltips\\UI-Tooltip-Background",
                    enable = false,
                    bgPad = 0,
                    width = 91,
                    textureName = "Blizzard Tooltip",
                    y = 0,
                    x = 1,
                    height = 50,
                    edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
                    anchor = "Left",
                    edgecolor = {
                        a = 100,
                        b = 100,
                        g = 100,
                        r = 100,
                    },
                    inset = 0,
                    scale = 100,
                },
                showInPetBattleUI = false,
                threat = {
                    scale = 100,
                    justifyV = 1,
                    width = 35,
                    y = 12,
                    x = 0,
                    justifyH = 1,
                    height = 12,
                    anchor = "top",
                    enable = true,
                },
                power = {
                    maxTextWidth = 98,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    format = "percent",
                    justifyV = "CENTER",
                    textureName = "Raid",
                    textY = 0,
                    textX = 0,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "BottomLeft",
                    arcEnd = 0,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    textHori = 2,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textVert = 2,
                    alpha = 100,
                    CurveOffset = 0,
                    y = -1,
                    mouseover = "value",
                    width = 124,
                    yTextOffset = 0,
                    x = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 13,
                    anchorText = "Center",
                    percent = true,
                    enable = true,
                },
                Class = {
                    textY = 0,
                    prevOrient = "HORIZONTAL",
                    enable = true,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopLeft",
                    format = "value",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    orient = "HORIZONTAL",
                    textVert = 2,
                    scale = 100,
                    alpha = 100,
                    width = 51,
                    y = -41,
                    x = 106,
                    mouseover = "value",
                    height = 12,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    textX = 0,
                },
                showInOverrideUI = false,
                icons = {
                    enable = true,
                    spacing = 0,
                    anchor = "Right",
                    angle = 46,
                    isLeftToRight = false,
                    columns = 8,
                    compress = 0,
                    IsLeftToRight = false,
                    scale = 78,
                    alpha = 100,
                    width = 55,
                    y = 0,
                    isTopToBottom = false,
                    style = "SQUARE",
                    reverse = true,
                    height = 55,
                    frameLayer = 4,
                    IsTopToBottom = true,
                    x = 0,
                },
                width = 173,
                health = {
                    textY = 0,
                    arcEnd = 0,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    enable = true,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    maxTextWidth = 98,
                    textHori = 2,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopLeft",
                    format = "percent",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    textVert = 2,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textX = 0,
                    x = 0,
                    yTextOffset = 0,
                    alpha = 100,
                    mouseover = "current",
                    width = 124,
                    y = 1,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 13,
                    anchorText = "Center",
                    percent = true,
                    arcMid = 0,
                },
                height = 47,
                name = {
                    enable = true,
                    justifyV = 2,
                    width = 98,
                    y = 0,
                    x = -51,
                    justifyH = 3,
                    anchor = "Right",
                    scale = 100,
                    height = 26,
                },
                model = {
                    zoom = 0,
                    frameLevel = 1,
                    frameLayer = 1,
                    scale = 1,
                    justifyV = "CENTER",
                    width = 133,
                    y = -45,
                    x = 110,
                    justifyH = "CENTER",
                    clickThru = true,
                    anchor = "BottomRight",
                    enable = false,
                    height = 197,
                    rotation = 0,
                },
                padH = 1,
                buffs = {
                    columns = 7,
                    color = {
                        a = 1,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    scale = 77,
                    rows = 2,
                    alpha = 100,
                    x = -2,
                    y = 48,
                    isTopToBottom = false,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomRight",
                    enable = false,
                    showBG = false,
                    isLeftToRight = true,
                },
                cast = {
                    maxTextWidth = 98.0000152587891,
                    enable = true,
                    multi = true,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    sparkY = 0,
                    scale = 100,
                    Sparkarc = 0,
                    textY = 0,
                    arcMid = 0,
                    anchor = "Left",
                    arcEnd = 0,
                    showBG = false,
                    frameLevel = 2,
                    x = 1,
                    textAnchor = "Center",
                    textX = 0,
                    frameLayer = 4,
                    yTextOffset = 0,
                    xTextOffset = 0,
                    alpha = 100,
                    width = 122,
                    y = 0,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 22,
                    anchorText = "Center",
                    textureName = "Blizzard",
                    textheight = 12,
                },
                level = {
                    scale = 100,
                    justifyV = 2,
                    width = 25,
                    y = 0,
                    x = 0,
                    justifyH = 2,
                    height = 26,
                    enable = true,
                    anchor = "Left",
                },
            },
            boss4 = {
                overlay = {
                    enable = false,
                },
                debuffs = {
                    columns = 7,
                    isLeftToRight = true,
                    scale = 77,
                    rows = 2,
                    alpha = 100,
                    isTopToBottom = false,
                    y = 47,
                    x = -354,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomLeft",
                    enable = false,
                    showBG = false,
                    color = {
                        a = 1,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                },
                scale = 1,
                Class = {
                    textY = 0,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopLeft",
                    format = "value",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    orient = "HORIZONTAL",
                    textX = 0,
                    enable = true,
                    alpha = 100,
                    width = 51,
                    y = -41,
                    x = 106,
                    mouseover = "value",
                    height = 12,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    textVert = 2,
                },
                padW = 0,
                focus = {
                    y = 0,
                    x = 2,
                    mouseOverTooltip = true,
                    anchor = "Right",
                    enable = true,
                    scale = 86,
                    alpha = 100,
                    usePortrait = true,
                },
                level = {
                    scale = 100,
                    justifyV = 2,
                    width = 25,
                    y = 0,
                    x = 0,
                    justifyH = 2,
                    height = 26,
                    anchor = "Left",
                    enable = true,
                },
                showInPetBattleUI = false,
                threat = {
                    scale = 100,
                    justifyV = 1,
                    width = 35,
                    y = 12,
                    x = 0,
                    justifyH = 1,
                    height = 12,
                    enable = true,
                    anchor = "top",
                },
                power = {
                    maxTextWidth = 98,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    format = "percent",
                    justifyV = "CENTER",
                    textureName = "Raid",
                    textY = 0,
                    textVert = 2,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "BottomLeft",
                    arcEnd = 0,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    height = 12,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textX = 0,
                    alpha = 100,
                    CurveOffset = 0,
                    y = -1,
                    mouseover = "value",
                    width = 124,
                    yTextOffset = 0,
                    x = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    enable = true,
                },
                class = {
                    scale = 100,
                    alpha = 100,
                    width = 51,
                    y = -51,
                    x = 0,
                    drop = true,
                    height = 12,
                    anchor = "BottomLeft",
                    enable = true,
                },
                showInOverrideUI = false,
                icons = {
                    enable = true,
                    spacing = 0,
                    anchor = "Right",
                    angle = 46,
                    alpha = 100,
                    columns = 8,
                    compress = 0,
                    IsTopToBottom = true,
                    frameLayer = 4,
                    IsLeftToRight = false,
                    width = 55,
                    y = 0,
                    x = 0,
                    style = "SQUARE",
                    reverse = true,
                    height = 55,
                    scale = 78,
                    isTopToBottom = false,
                    isLeftToRight = false,
                },
                width = 173,
                background = {
                    edgeSize = 13,
                    enable = true,
                    inset = 0,
                    color = {
                        a = 0.5,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                    bgPad = 0,
                    edgecolor = {
                        a = 100,
                        r = 100,
                        g = 100,
                        b = 100,
                    },
                    width = 91,
                    y = 0,
                    x = 0,
                    anchor = "Left",
                    edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
                    height = 51,
                    textureName = "Blizzard Tooltip",
                    texturePath = "Interface\\Tooltips\\UI-Tooltip-Background",
                    scale = 100,
                },
                padH = 0,
                name = {
                    enable = true,
                    justifyV = 2,
                    width = 98,
                    y = 0,
                    x = -51,
                    justifyH = 3,
                    anchor = "Right",
                    height = 26,
                    scale = 100,
                },
                model = {
                    zoom = 0,
                    frameLevel = 1,
                    frameLayer = 1,
                    scale = 1,
                    justifyV = "CENTER",
                    width = 133,
                    y = -45,
                    x = 110,
                    justifyH = "CENTER",
                    rotation = 0,
                    anchor = "BottomRight",
                    height = 197,
                    enable = false,
                    clickThru = true,
                },
                height = 47,
                buffs = {
                    columns = 7,
                    isLeftToRight = true,
                    color = {
                        a = 1,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                    rows = 2,
                    alpha = 100,
                    x = -2,
                    y = 48,
                    isTopToBottom = false,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomRight",
                    enable = false,
                    showBG = false,
                    scale = 77,
                },
                health = {
                    textY = 0,
                    arcEnd = 0,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    enable = true,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    maxTextWidth = 98,
                    height = 12,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopLeft",
                    format = "percent",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    textX = 0,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textVert = 2,
                    x = 0,
                    yTextOffset = 0,
                    mouseover = "current",
                    alpha = 100,
                    width = 124,
                    y = 0,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    arcMid = 0,
                },
                cast = {
                    maxTextWidth = 98,
                    scale = 100,
                    multi = true,
                    showBG = false,
                    sparkY = 0,
                    enable = true,
                    Sparkarc = 0,
                    textY = 0,
                    arcMid = 0,
                    anchor = "Left",
                    arcEnd = 0,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    frameLevel = 2,
                    x = 1,
                    textAnchor = "Center",
                    textX = 0,
                    frameLayer = 4,
                    yTextOffset = 0,
                    xTextOffset = 0,
                    alpha = 100,
                    width = 122,
                    y = 0,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 22,
                    anchorText = "Center",
                    textureName = "Blizzard",
                    textheight = 12,
                },
            },
            player = {
                overlay = {
                    enable = false,
                },
                debuffs = {
                    columns = 6,
                    scale = 76,
                    color = {
                        a = 1,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    rows = 3,
                    alpha = 100,
                    isTopToBottom = true,
                    y = 69,
                    x = 42,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "Bottom",
                    enable = false,
                    showBG = false,
                    isLeftToRight = true,
                },
                scale = 1,
                Class = {
                    textY = 0,
                    prevOrient = "HORIZONTAL",
                    enable = true,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "BottomRight",
                    format = "value",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    orient = "HORIZONTAL",
                    textVert = 2,
                    scale = 100,
                    alpha = 100,
                    width = 51,
                    y = 41,
                    x = -106,
                    mouseover = "value",
                    height = 12,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    textX = 0,
                },
                cast = {
                    arcMid = 5,
                    maxTextWidth = 300,
                    enable = true,
                    textheight = 166,
                    scale = 100,
                    sparkConfig = false,
                    showBG = false,
                    textureName = "Bar",
                    textY = 7,
                    Sparkarc = -69,
                    textAnchor = "Center",
                    drop = false,
                    anchor = "Center",
                    arcEnd = -135.303436279297,
                    texturePath = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
                    xTextOffset = 0,
                    yTextOffset = 0,
                    reverseArc = false,
                    textX = 0,
                    frameLayer = 4,
                    frameLevel = 2,
                    x = 0,
                    alpha = 100,
                    width = 205,
                    y = 186,
                    CurveOffset = 0,
                    mouseOverTooltip = false,
                    arc = -69,
                    height = 50,
                    anchorText = "Center",
                    multi = true,
                    sparkY = 6,
                },
                fadeAlpha = 0.65,
                focus = {
                    y = 0,
                    usePortrait = true,
                    mouseOverTooltip = true,
                    x = -36,
                    enable = false,
                    scale = 80,
                    alpha = 100,
                    anchor = "Left",
                },
                level = {
                    scale = 100,
                    justifyV = 2,
                    width = 25,
                    y = 0,
                    x = 0,
                    justifyH = 2,
                    anchor = "Right",
                    height = 26,
                    enable = false,
                },
                showInPetBattleUI = false,
                threat = {
                    scale = 100,
                    justifyV = 3,
                    width = 35,
                    y = 0,
                    x = 0,
                    justifyH = 3,
                    height = 12,
                    anchor = "Bottom",
                    enable = true,
                },
                power = {
                    maxTextWidth = 300,
                    format = "percent",
                    prevOrient = "VERTICAL",
                    enable = true,
                    textY = -6,
                    justifyV = "CENTER",
                    textureName = "Bar-Right",
                    textX = -75,
                    height = 199,
                    justifyH = "CENTER",
                    drop = false,
                    anchor = "BottomRight",
                    arcEnd = 4,
                    texturePath = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar-Right",
                    xTextOffset = 0,
                    orient = "VERTICAL",
                    reverseArc = false,
                    textVert = 2,
                    alpha = 100,
                    CurveOffset = 0,
                    y = -4,
                    mouseover = "value",
                    width = 76,
                    yTextOffset = 0,
                    x = 47,
                    mouseOverTooltip = false,
                    arc = 0,
                    textHori = 3,
                    anchorText = "BottomRight",
                    percent = true,
                    scale = 100,
                },
                showInOverrideUI = false,
                alpha = 0.9,
                width = 226,
                class = {
                    textY = -8,
                    enable = true,
                    sparkConfig = false,
                    textureName = "Bar",
                    arcMid = -9,
                    anchor = "Center",
                    arcEnd = 47,
                    texturePath = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
                    textX = 0,
                    alpha = 100,
                    width = 207,
                    y = -5,
                    sparkSize = 39,
                    height = 64,
                    drop = false,
                    x = 0,
                    scale = 100,
                },
                background = {
                    edgeSize = 13,
                    scale = 100,
                    texturePath = "Interface\\Tooltips\\UI-Tooltip-Background",
                    enable = false,
                    bgPad = 0,
                    textureName = "Blizzard Tooltip",
                    width = 100,
                    y = 0,
                    edgecolor = {
                        a = 100,
                        b = 100,
                        g = 100,
                        r = 100,
                    },
                    height = 100,
                    edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
                    anchor = "Center",
                    x = 0,
                    inset = 0,
                    color = {
                        a = 0.5,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                },
                health = {
                    arcEnd = 37.0818939208984,
                    textY = -6,
                    scale = 96,
                    prevOrient = "VERTICAL",
                    enable = true,
                    maxTextWidth = 300,
                    justifyV = "CENTER",
                    textureName = "Bar",
                    textHori = 3,
                    textVert = 1,
                    justifyH = "CENTER",
                    arcMid = 0,
                    anchor = "BottomLeft",
                    format = "percent",
                    texturePath = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
                    xTextOffset = 0,
                    orient = "VERTICAL",
                    reverseArc = false,
                    textX = 59,
                    x = -47,
                    yTextOffset = 0,
                    mouseover = "value",
                    alpha = 100,
                    width = 76,
                    y = -4,
                    CurveOffset = 0,
                    mouseOverTooltip = false,
                    arc = 0,
                    height = 199,
                    anchorText = "BottomLeft",
                    percent = true,
                    drop = false,
                },
                model = {
                    zoom = 98,
                    frameLevel = 1,
                    frameLayer = 3,
                    scale = 51,
                    justifyV = "CENTER",
                    width = 307,
                    y = 45,
                    x = -110,
                    justifyH = "CENTER",
                    clickThru = true,
                    anchor = "TopLeft",
                    enable = false,
                    height = 207,
                    rotation = 0,
                },
                height = 10,
                buffs = {
                    columns = 7,
                    color = {
                        a = 1,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    scale = 64,
                    rows = 2,
                    alpha = 100,
                    x = 31,
                    y = 35,
                    isTopToBottom = false,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "TopLeft",
                    enable = false,
                    showBG = true,
                    isLeftToRight = true,
                },
                name = {
                    enable = false,
                    justifyV = 2,
                    width = 98,
                    y = 0,
                    x = 16,
                    justifyH = 1,
                    height = 26,
                    anchor = "Left",
                    scale = 100,
                },
                icons = {
                    enable = true,
                    spacing = 0,
                    anchor = "BottomLeft",
                    angle = 293,
                    columns = 1,
                    frameLayer = 1,
                    isTopToBottom = true,
                    alpha = 100,
                    isLeftToRight = true,
                    width = 76,
                    y = -5,
                    x = -51,
                    style = "ROUND",
                    IsLeftToRight = false,
                    height = 196,
                    compress = 52,
                    scale = 102,
                    IsTopToBottom = true,
                },
            },
            focus = {
                overlay = {
                    enable = false,
                },
                debuffs = {
                    columns = 7,
                    scale = 77,
                    color = {
                        a = 1,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    rows = 2,
                    alpha = 100,
                    isTopToBottom = false,
                    y = 47,
                    x = 354,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomRight",
                    enable = false,
                    showBG = false,
                    isLeftToRight = true,
                },
                scale = 1.02,
                Class = {
                    textY = 0,
                    prevOrient = "HORIZONTAL",
                    enable = true,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopRight",
                    format = "value",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    orient = "HORIZONTAL",
                    textVert = 2,
                    scale = 100,
                    alpha = 100,
                    width = 51,
                    y = -41,
                    x = -106,
                    mouseover = "value",
                    height = 12,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    textX = 0,
                },
                cast = {
                    drop = false,
                    textY = 0,
                    multi = true,
                    sparkY = 0,
                    scale = 100,
                    sparkConfig = false,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    textheight = 12,
                    maxTextWidth = 98,
                    Sparkarc = 0,
                    reverseArc = false,
                    arcMid = 0,
                    anchor = "Right",
                    arcEnd = 0,
                    showBG = false,
                    CurveOffset = 0,
                    yTextOffset = 0,
                    textAnchor = "Center",
                    frameLevel = 2,
                    frameLayer = 4,
                    textX = 0,
                    x = -1,
                    alpha = 100,
                    width = 122,
                    y = 0,
                    xTextOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 22,
                    anchorText = "Center",
                    enable = true,
                    textureName = "Blizzard",
                },
                fadeAlpha = 0.65,
                focus = {
                    y = 0,
                    usePortrait = true,
                    mouseOverTooltip = true,
                    x = -2,
                    enable = true,
                    scale = 86,
                    alpha = 100,
                    anchor = "Left",
                },
                level = {
                    scale = 100,
                    justifyV = 2,
                    width = 25,
                    y = 0,
                    x = 0,
                    justifyH = 2,
                    height = 26,
                    enable = true,
                    anchor = "Right",
                },
                showInPetBattleUI = false,
                threat = {
                    scale = 100,
                    justifyV = 1,
                    width = 35,
                    y = 12,
                    x = 0,
                    justifyH = 3,
                    height = 12,
                    anchor = "top",
                    enable = true,
                },
                power = {
                    maxTextWidth = 98,
                    format = "percent",
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    textY = 0,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    textX = 0,
                    textHori = 2,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "BottomRight",
                    arcEnd = 0,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    xTextOffset = 0,
                    orient = "HORIZONTAL",
                    reverseArc = false,
                    textVert = 2,
                    alpha = 100,
                    CurveOffset = 0,
                    y = -1,
                    mouseover = "value",
                    width = 124,
                    yTextOffset = 0,
                    x = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 12,
                    anchorText = "Center",
                    percent = true,
                    enable = true,
                },
                showInOverrideUI = false,
                alpha = 0.9,
                width = 173,
                class = {
                    textY = -8,
                    enable = true,
                    sparkConfig = false,
                    textureName = "Bar",
                    drop = true,
                    anchor = "BottomRight",
                    arcEnd = 47,
                    texturePath = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
                    textX = 0,
                    alpha = 100,
                    width = 51,
                    y = -51,
                    x = 0,
                    height = 12,
                    sparkSize = 39,
                    scale = 100,
                    arcMid = -9,
                },
                icons = {
                    enable = true,
                    spacing = 0,
                    anchor = "Left",
                    angle = 46,
                    isLeftToRight = true,
                    columns = 8,
                    compress = 0,
                    IsLeftToRight = false,
                    scale = 78,
                    alpha = 100,
                    width = 55,
                    y = 0,
                    isTopToBottom = false,
                    style = "SQUARE",
                    reverse = true,
                    height = 55,
                    frameLayer = 4,
                    IsTopToBottom = true,
                    x = 0,
                },
                health = {
                    arcEnd = 0,
                    textY = 0,
                    scale = 100,
                    prevOrient = "HORIZONTAL",
                    enable = true,
                    maxTextWidth = 98,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    textHori = 2,
                    textVert = 2,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopRight",
                    format = "percent",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    xTextOffset = 0,
                    orient = "HORIZONTAL",
                    reverseArc = false,
                    textX = 0,
                    x = 0,
                    yTextOffset = 0,
                    alpha = 100,
                    mouseover = "current",
                    width = 124,
                    y = 0,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 12,
                    anchorText = "Center",
                    percent = true,
                    arcMid = 0,
                },
                model = {
                    zoom = 0,
                    frameLevel = 1,
                    frameLayer = 1,
                    scale = 1,
                    justifyV = "CENTER",
                    width = 133,
                    y = -45,
                    x = -110,
                    justifyH = "CENTER",
                    clickThru = true,
                    anchor = "BottomLeft",
                    enable = false,
                    height = 197,
                    rotation = 0,
                },
                height = 47,
                buffs = {
                    columns = 7,
                    color = {
                        a = 1,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    scale = 77,
                    rows = 2,
                    alpha = 100,
                    x = 2,
                    y = 48,
                    isTopToBottom = false,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomLeft",
                    enable = false,
                    showBG = false,
                    isLeftToRight = true,
                },
                name = {
                    enable = true,
                    justifyV = 2,
                    width = 98,
                    y = 0,
                    x = 51,
                    justifyH = 1,
                    anchor = "Left",
                    scale = 100,
                    height = 26,
                },
                background = {
                    edgeSize = 13,
                    color = {
                        a = 0.5,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    texturePath = "Interface\\Tooltips\\UI-Tooltip-Background",
                    enable = true,
                    bgPad = 0,
                    width = 91,
                    textureName = "Blizzard Tooltip",
                    y = 0,
                    x = 0,
                    height = 51,
                    edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
                    anchor = "Right",
                    edgecolor = {
                        a = 100,
                        b = 100,
                        g = 100,
                        r = 100,
                    },
                    inset = 0,
                    scale = 100,
                },
            },
            target = {
                overlay = {
                    enable = false,
                },
                debuffs = {
                    columns = 7,
                    scale = 77,
                    color = {
                        a = 1,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    rows = 2,
                    alpha = 100,
                    isTopToBottom = false,
                    y = 47,
                    x = 354,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomRight",
                    enable = true,
                    showBG = false,
                    isLeftToRight = true,
                },
                scale = 1,
                Class = {
                    textY = 0,
                    prevOrient = "HORIZONTAL",
                    enable = true,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopRight",
                    format = "value",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    orient = "HORIZONTAL",
                    textVert = 2,
                    scale = 100,
                    alpha = 100,
                    width = 51,
                    y = -41,
                    x = -106,
                    mouseover = "value",
                    height = 12,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    textX = 0,
                },
                cast = {
                    maxTextWidth = 14,
                    enable = true,
                    multi = true,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    sparkY = 0,
                    scale = 100,
                    Sparkarc = 0,
                    textY = 0,
                    arcMid = 0,
                    anchor = "Right",
                    arcEnd = 0,
                    showBG = false,
                    frameLevel = 2,
                    x = 0,
                    textAnchor = "Left",
                    textX = -15,
                    frameLayer = 4,
                    yTextOffset = 0,
                    xTextOffset = 24,
                    alpha = 100,
                    width = 122,
                    y = 0,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 22,
                    anchorText = "Right",
                    textureName = "Blizzard",
                    textheight = 12,
                },
                focus = {
                    y = 0,
                    usePortrait = true,
                    mouseOverTooltip = true,
                    x = -2,
                    enable = true,
                    scale = 86,
                    alpha = 100,
                    anchor = "Left",
                },
                level = {
                    scale = 100,
                    justifyV = 2,
                    width = 25,
                    y = 0,
                    x = 0,
                    justifyH = 2,
                    height = 26,
                    enable = true,
                    anchor = "Right",
                },
                showInPetBattleUI = false,
                threat = {
                    scale = 100,
                    justifyV = 1,
                    width = 35,
                    y = 12,
                    x = 0,
                    justifyH = 3,
                    height = 12,
                    anchor = "top",
                    enable = true,
                },
                power = {
                    maxTextWidth = 98,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    format = "percent",
                    justifyV = "CENTER",
                    textureName = "Raid",
                    textY = 0,
                    textX = 0,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "BottomRight",
                    arcEnd = 0,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    textHori = 2,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textVert = 2,
                    alpha = 100,
                    CurveOffset = 0,
                    y = -1,
                    mouseover = "value",
                    width = 124,
                    yTextOffset = 0,
                    x = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 13,
                    anchorText = "Center",
                    percent = true,
                    enable = true,
                },
                class = {
                    scale = 100,
                    alpha = 100,
                    width = 51,
                    y = -51,
                    x = 0,
                    drop = true,
                    height = 12,
                    anchor = "BottomRight",
                    enable = true,
                },
                showInOverrideUI = false,
                icons = {
                    enable = true,
                    spacing = 4,
                    anchor = "Left",
                    angle = 46,
                    isLeftToRight = true,
                    columns = 8,
                    compress = 0,
                    IsLeftToRight = false,
                    scale = 71,
                    alpha = 100,
                    width = 55,
                    y = 0,
                    isTopToBottom = false,
                    style = "SQUARE",
                    reverse = true,
                    height = 55,
                    frameLayer = 4,
                    IsTopToBottom = true,
                    x = 0,
                },
                width = 173,
                padW = 1,
                padH = 1,
                health = {
                    textY = 0,
                    arcEnd = 0,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    enable = true,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    maxTextWidth = 98,
                    textHori = 2,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopRight",
                    format = "percent",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    textVert = 2,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textX = 0,
                    x = 0,
                    yTextOffset = 0,
                    alpha = 100,
                    mouseover = "current",
                    width = 124,
                    y = 1,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 13,
                    anchorText = "Center",
                    percent = true,
                    arcMid = 0,
                },
                model = {
                    zoom = 0,
                    frameLevel = 1,
                    frameLayer = 1,
                    scale = 1,
                    justifyV = "CENTER",
                    width = 133,
                    y = -45,
                    x = -110,
                    justifyH = "CENTER",
                    clickThru = true,
                    anchor = "BottomLeft",
                    enable = false,
                    height = 197,
                    rotation = 0,
                },
                height = 47,
                buffs = {
                    columns = 7,
                    color = {
                        a = 1,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    scale = 77,
                    rows = 2,
                    alpha = 100,
                    x = 2,
                    y = 48,
                    isTopToBottom = false,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomLeft",
                    enable = true,
                    showBG = false,
                    isLeftToRight = true,
                },
                name = {
                    enable = true,
                    justifyV = 2,
                    width = 98,
                    y = 0,
                    x = 51,
                    justifyH = 1,
                    anchor = "Left",
                    scale = 100,
                    height = 26,
                },
                background = {
                    edgeSize = 13,
                    color = {
                        a = 0.5,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    texturePath = "Interface\\Tooltips\\UI-Tooltip-Background",
                    enable = false,
                    bgPad = 0,
                    width = 100,
                    textureName = "Blizzard Tooltip",
                    y = 0,
                    x = -1,
                    height = 100,
                    edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
                    anchor = "Right",
                    edgecolor = {
                        a = 100,
                        b = 100,
                        g = 100,
                        r = 100,
                    },
                    inset = 0,
                    scale = 100,
                },
            },
            playerpet = {
                overlay = {
                    enable = false,
                },
                debuffs = {
                    columns = 7,
                    scale = 77,
                    color = {
                        a = 1,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    rows = 2,
                    alpha = 100,
                    isTopToBottom = false,
                    y = 47,
                    x = 354,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomRight",
                    enable = false,
                    showBG = false,
                    isLeftToRight = true,
                },
                scale = 1,
                Class = {
                    textY = 0,
                    prevOrient = "HORIZONTAL",
                    enable = true,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopRight",
                    format = "value",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    orient = "HORIZONTAL",
                    textVert = 2,
                    scale = 100,
                    alpha = 100,
                    width = 51,
                    y = -41,
                    x = -106,
                    mouseover = "value",
                    height = 12,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    textX = 0,
                },
                cast = {
                    maxTextWidth = 98,
                    enable = true,
                    multi = true,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    sparkY = 0,
                    scale = 100,
                    Sparkarc = 0,
                    textY = 0,
                    arcMid = 0,
                    anchor = "Right",
                    arcEnd = 0,
                    showBG = false,
                    frameLevel = 2,
                    x = -1,
                    textAnchor = "Center",
                    textX = 0,
                    frameLayer = 4,
                    yTextOffset = 0,
                    xTextOffset = 0,
                    alpha = 100,
                    width = 122,
                    y = 0,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 22,
                    anchorText = "Center",
                    textureName = "Blizzard",
                    textheight = 12,
                },
                focus = {
                    y = 0,
                    usePortrait = true,
                    mouseOverTooltip = true,
                    x = -2,
                    enable = true,
                    scale = 86,
                    alpha = 100,
                    anchor = "Left",
                },
                level = {
                    scale = 100,
                    justifyV = 2,
                    width = 25,
                    y = 0,
                    x = 0,
                    justifyH = 2,
                    height = 26,
                    enable = true,
                    anchor = "Right",
                },
                showInPetBattleUI = false,
                threat = {
                    scale = 100,
                    justifyV = 1,
                    width = 35,
                    y = 12,
                    x = 0,
                    justifyH = 3,
                    height = 12,
                    anchor = "top",
                    enable = true,
                },
                power = {
                    maxTextWidth = 98,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    format = "percent",
                    justifyV = "CENTER",
                    textureName = "Raid",
                    textY = 0,
                    textX = 0,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "BottomRight",
                    arcEnd = 0,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    textHori = 2,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textVert = 2,
                    alpha = 100,
                    CurveOffset = 0,
                    y = -1,
                    mouseover = "value",
                    width = 124,
                    yTextOffset = 0,
                    x = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 12,
                    anchorText = "Center",
                    percent = true,
                    enable = true,
                },
                showInOverrideUI = false,
                icons = {
                    enable = true,
                    spacing = 0,
                    anchor = "Left",
                    angle = 46,
                    alpha = 100,
                    columns = 8,
                    frameLayer = 4,
                    IsLeftToRight = false,
                    scale = 78,
                    isLeftToRight = true,
                    width = 55,
                    y = 0,
                    isTopToBottom = false,
                    style = "SQUARE",
                    reverse = true,
                    height = 55,
                    compress = 0,
                    x = 0,
                    IsTopToBottom = true,
                },
                width = 173,
                class = {
                    scale = 100,
                    alpha = 100,
                    width = 51,
                    y = -51,
                    x = 0,
                    drop = true,
                    height = 12,
                    anchor = "BottomRight",
                    enable = true,
                },
                health = {
                    textY = 0,
                    arcEnd = 0,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    enable = true,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    maxTextWidth = 98,
                    textHori = 2,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopRight",
                    format = "percent",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    textVert = 2,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textX = 0,
                    x = 0,
                    yTextOffset = 0,
                    alpha = 100,
                    mouseover = "current",
                    width = 124,
                    y = 0,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 12,
                    anchorText = "Center",
                    percent = true,
                    arcMid = 0,
                },
                model = {
                    zoom = 0,
                    frameLevel = 1,
                    frameLayer = 1,
                    scale = 1,
                    justifyV = "CENTER",
                    width = 133,
                    y = -45,
                    x = -110,
                    justifyH = "CENTER",
                    clickThru = true,
                    anchor = "BottomLeft",
                    enable = false,
                    height = 197,
                    rotation = 0,
                },
                height = 47,
                buffs = {
                    columns = 7,
                    color = {
                        a = 1,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    scale = 77,
                    rows = 2,
                    alpha = 100,
                    x = 2,
                    y = 48,
                    isTopToBottom = false,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomLeft",
                    enable = false,
                    showBG = false,
                    isLeftToRight = true,
                },
                name = {
                    enable = true,
                    justifyV = 2,
                    width = 98,
                    y = 0,
                    x = 51,
                    justifyH = 1,
                    anchor = "Left",
                    scale = 100,
                    height = 26,
                },
                background = {
                    edgeSize = 13,
                    color = {
                        a = 0.5,
                        b = 0,
                        g = 0,
                        r = 0,
                    },
                    texturePath = "Interface\\Tooltips\\UI-Tooltip-Background",
                    enable = true,
                    bgPad = 0,
                    width = 91,
                    textureName = "Blizzard Tooltip",
                    y = 0,
                    x = 0,
                    height = 51,
                    edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
                    anchor = "Right",
                    edgecolor = {
                        a = 100,
                        b = 100,
                        g = 100,
                        r = 100,
                    },
                    inset = 0,
                    scale = 100,
                },
            },
            boss2 = {
                overlay = {
                    enable = false,
                },
                debuffs = {
                    columns = 7,
                    alpha = 100,
                    color = {
                        a = 1,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                    rows = 2,
                    isLeftToRight = true,
                    isTopToBottom = false,
                    y = 47,
                    x = -354,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomLeft",
                    enable = false,
                    showBG = false,
                    scale = 77,
                },
                scale = 1,
                Class = {
                    textY = 0,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopLeft",
                    format = "value",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    orient = "HORIZONTAL",
                    textX = 0,
                    enable = true,
                    alpha = 100,
                    width = 51,
                    y = -41,
                    x = 106,
                    mouseover = "value",
                    height = 12,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    textVert = 2,
                },
                padW = 0,
                focus = {
                    y = 0,
                    x = 2,
                    mouseOverTooltip = true,
                    enable = true,
                    anchor = "Right",
                    scale = 86,
                    alpha = 100,
                    usePortrait = true,
                },
                level = {
                    scale = 100,
                    justifyV = 2,
                    width = 25,
                    y = 0,
                    x = 0,
                    justifyH = 2,
                    height = 26,
                    anchor = "Left",
                    enable = true,
                },
                showInPetBattleUI = false,
                threat = {
                    scale = 100,
                    justifyV = 1,
                    width = 35,
                    y = 12,
                    x = 0,
                    justifyH = 1,
                    height = 12,
                    enable = true,
                    anchor = "top",
                },
                power = {
                    maxTextWidth = 98,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    format = "percent",
                    justifyV = "CENTER",
                    textureName = "Raid",
                    textY = 0,
                    textVert = 2,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "BottomLeft",
                    arcEnd = 0,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    height = 12,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textX = 0,
                    alpha = 100,
                    CurveOffset = 0,
                    y = -1,
                    mouseover = "value",
                    width = 124,
                    yTextOffset = 0,
                    x = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    enable = true,
                },
                class = {
                    scale = 100,
                    alpha = 100,
                    width = 51,
                    y = -51,
                    x = 0,
                    drop = true,
                    height = 12,
                    anchor = "BottomLeft",
                    enable = true,
                },
                showInOverrideUI = false,
                icons = {
                    enable = true,
                    spacing = 0,
                    anchor = "Right",
                    angle = 46,
                    IsLeftToRight = false,
                    columns = 8,
                    compress = 0,
                    IsTopToBottom = true,
                    frameLayer = 4,
                    isLeftToRight = false,
                    width = 55,
                    y = 0,
                    x = 0,
                    style = "SQUARE",
                    reverse = true,
                    height = 55,
                    scale = 78,
                    isTopToBottom = false,
                    alpha = 100,
                },
                width = 173,
                background = {
                    edgeSize = 13,
                    color = {
                        a = 0.5,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                    inset = 0,
                    scale = 100,
                    bgPad = 0,
                    x = 0,
                    textureName = "Blizzard Tooltip",
                    y = 0,
                    edgecolor = {
                        a = 100,
                        r = 100,
                        g = 100,
                        b = 100,
                    },
                    anchor = "Left",
                    edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
                    height = 51,
                    width = 91,
                    texturePath = "Interface\\Tooltips\\UI-Tooltip-Background",
                    enable = true,
                },
                padH = 0,
                health = {
                    textY = 0,
                    arcEnd = 0,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    enable = true,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    maxTextWidth = 98,
                    height = 12,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopLeft",
                    format = "percent",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    textX = 0,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textVert = 2,
                    x = 0,
                    yTextOffset = 0,
                    mouseover = "current",
                    alpha = 100,
                    width = 124,
                    y = 0,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    arcMid = 0,
                },
                model = {
                    zoom = 0,
                    frameLevel = 1,
                    frameLayer = 1,
                    scale = 1,
                    justifyV = "CENTER",
                    width = 133,
                    y = -45,
                    x = 110,
                    justifyH = "CENTER",
                    rotation = 0,
                    anchor = "BottomRight",
                    height = 197,
                    enable = false,
                    clickThru = true,
                },
                height = 47,
                buffs = {
                    columns = 7,
                    alpha = 100,
                    scale = 77,
                    rows = 2,
                    isLeftToRight = true,
                    x = -2,
                    y = 48,
                    isTopToBottom = false,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomRight",
                    enable = false,
                    showBG = false,
                    color = {
                        a = 1,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                },
                name = {
                    enable = true,
                    justifyV = 2,
                    width = 98,
                    y = 0,
                    x = -51,
                    justifyH = 3,
                    anchor = "Right",
                    height = 26,
                    scale = 100,
                },
                cast = {
                    maxTextWidth = 98,
                    scale = 100,
                    multi = true,
                    showBG = false,
                    textureName = "Blizzard",
                    sparkY = 0,
                    Sparkarc = 0,
                    textY = 0,
                    arcMid = 0,
                    anchor = "Left",
                    arcEnd = 0,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    frameLevel = 2,
                    x = 1,
                    textAnchor = "Center",
                    textX = 0,
                    frameLayer = 4,
                    yTextOffset = 0,
                    xTextOffset = 0,
                    alpha = 100,
                    width = 122,
                    y = 0,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 22,
                    anchorText = "Center",
                    enable = true,
                    textheight = 12,
                },
            },
            boss3 = {
                overlay = {
                    enable = false,
                },
                debuffs = {
                    columns = 7,
                    alpha = 100,
                    color = {
                        a = 1,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                    rows = 2,
                    isLeftToRight = true,
                    isTopToBottom = false,
                    y = 47,
                    x = 354,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomRight",
                    enable = false,
                    showBG = false,
                    scale = 77,
                },
                scale = 1,
                Class = {
                    textY = 0,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopRight",
                    format = "value",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    orient = "HORIZONTAL",
                    textX = 0,
                    enable = true,
                    alpha = 100,
                    width = 51,
                    y = -41,
                    x = -106,
                    mouseover = "value",
                    height = 12,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    textVert = 2,
                },
                padW = 0,
                focus = {
                    y = 0,
                    x = -2,
                    mouseOverTooltip = true,
                    enable = true,
                    anchor = "Left",
                    scale = 86,
                    alpha = 100,
                    usePortrait = true,
                },
                level = {
                    scale = 100,
                    justifyV = 2,
                    width = 25,
                    y = 0,
                    x = 0,
                    justifyH = 2,
                    height = 26,
                    anchor = "Right",
                    enable = true,
                },
                showInPetBattleUI = false,
                threat = {
                    scale = 100,
                    justifyV = 1,
                    width = 35,
                    y = 12,
                    x = 0,
                    justifyH = 3,
                    height = 12,
                    enable = true,
                    anchor = "top",
                },
                power = {
                    maxTextWidth = 98,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    format = "percent",
                    justifyV = "CENTER",
                    textureName = "Raid",
                    textY = 0,
                    textVert = 2,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "BottomRight",
                    arcEnd = 0,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    height = 12,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textX = 0,
                    alpha = 100,
                    CurveOffset = 0,
                    y = -1,
                    mouseover = "value",
                    width = 124,
                    yTextOffset = 0,
                    x = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    enable = true,
                },
                class = {
                    scale = 100,
                    alpha = 100,
                    width = 51,
                    y = -51,
                    x = 0,
                    drop = true,
                    height = 12,
                    anchor = "BottomRight",
                    enable = true,
                },
                showInOverrideUI = false,
                icons = {
                    enable = true,
                    spacing = 0,
                    anchor = "Left",
                    angle = 46,
                    IsLeftToRight = false,
                    columns = 8,
                    compress = 0,
                    IsTopToBottom = true,
                    frameLayer = 4,
                    isLeftToRight = true,
                    width = 55,
                    y = 0,
                    x = 0,
                    style = "SQUARE",
                    reverse = true,
                    height = 55,
                    scale = 78,
                    isTopToBottom = false,
                    alpha = 100,
                },
                width = 173,
                background = {
                    edgeSize = 13,
                    color = {
                        a = 0.5,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                    inset = 0,
                    scale = 100,
                    bgPad = 0,
                    x = 0,
                    textureName = "Blizzard Tooltip",
                    y = 0,
                    edgecolor = {
                        a = 100,
                        r = 100,
                        g = 100,
                        b = 100,
                    },
                    anchor = "Right",
                    edgeFile = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
                    height = 51,
                    width = 91,
                    texturePath = "Interface\\Tooltips\\UI-Tooltip-Background",
                    enable = true,
                },
                padH = 0,
                health = {
                    textY = 0,
                    arcEnd = 0,
                    prevOrient = "HORIZONTAL",
                    scale = 100,
                    enable = true,
                    justifyV = "CENTER",
                    textureName = "Raid",
                    maxTextWidth = 98,
                    height = 12,
                    justifyH = "CENTER",
                    drop = true,
                    anchor = "TopRight",
                    format = "percent",
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    textX = 0,
                    orient = "HORIZONTAL",
                    xTextOffset = 0,
                    textVert = 2,
                    x = 0,
                    yTextOffset = 0,
                    mouseover = "current",
                    alpha = 100,
                    width = 124,
                    y = 0,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    textHori = 2,
                    anchorText = "Center",
                    percent = true,
                    arcMid = 0,
                },
                model = {
                    zoom = 0,
                    frameLevel = 1,
                    frameLayer = 1,
                    scale = 1,
                    justifyV = "CENTER",
                    width = 133,
                    y = -45,
                    x = -110,
                    justifyH = "CENTER",
                    rotation = 0,
                    anchor = "BottomLeft",
                    height = 197,
                    enable = false,
                    clickThru = true,
                },
                height = 47,
                buffs = {
                    columns = 7,
                    alpha = 100,
                    scale = 77,
                    rows = 2,
                    isLeftToRight = true,
                    x = 2,
                    y = 48,
                    isTopToBottom = false,
                    sort = "Duration",
                    spacing = 0,
                    anchor = "BottomLeft",
                    enable = false,
                    showBG = false,
                    color = {
                        a = 1,
                        r = 0,
                        g = 0,
                        b = 0,
                    },
                },
                name = {
                    enable = true,
                    justifyV = 2,
                    width = 98,
                    y = 0,
                    x = 51,
                    justifyH = 1,
                    anchor = "Left",
                    height = 26,
                    scale = 100,
                },
                cast = {
                    maxTextWidth = 98,
                    scale = 100,
                    multi = true,
                    showBG = false,
                    textureName = "Blizzard",
                    sparkY = 0,
                    Sparkarc = 0,
                    textY = 0,
                    arcMid = 0,
                    anchor = "Right",
                    arcEnd = 0,
                    texturePath = "Interface\\TargetingFrame\\UI-StatusBar",
                    frameLevel = 2,
                    x = -1,
                    textAnchor = "Center",
                    textX = 0,
                    frameLayer = 4,
                    yTextOffset = 0,
                    xTextOffset = 0,
                    alpha = 100,
                    width = 122,
                    y = 0,
                    CurveOffset = 0,
                    mouseOverTooltip = true,
                    arc = 0,
                    height = 22,
                    anchorText = "Center",
                    enable = true,
                    textheight = 12,
                },
            },
        },  
    }
    
    local profiles = {}
    local info  = {}
    local function GetSettings()
        profiles = {}
            for profile, settings in pairs(CopyTable(DominosDB.profiles)) do
                for i, b in pairs(settings) do
                    for id, sets in pairs(settings.frames) do
                        if bar:IsViable(id) then
                            info[id] = Copy(sets)
                        end
                    end
                end
                profiles[profile] = Copy(info)
                info = {}                
            end
            for profile, settings in pairs(Copy(Base)) do
                profiles[profile] = settings
            end
        
        Dominos_Units= profiles
        
        return profiles
    end

    function OnTopMenuShow(panel)
        local info = UIDropDownMenu_CreateInfo()
        for profile, settings in pairs(GetSettings()) do
            wipe(info)
            info.text = profile
            info.value = profile
            info.keepShownOnClick = true
            info.displayMode = "MENU"
            info.hasArrow = 1
            UIDropDownMenu_AddButton(info)
        end
    end

    function OnSubMenuShow(panel, level, ...)
        local owner = panel.owner
        if not UIDROPDOWNMENU_MENU_VALUE then
            return
        end
        print(UIDROPDOWNMENU_MENU_VALUE, "~", ...)
        local info = UIDropDownMenu_CreateInfo()
        for id, layout in pairs(profiles[UIDROPDOWNMENU_MENU_VALUE]) do
            wipe(info)
            info.text = id
            info.func = function()
                local p = Copy(layout, bar.master.db.profile.frames[owner.id])
                bar.master.db.profile.frames[owner.id] = p
                owner.sets = p
                owner:Reload()
                owner:Layout()
                owner:Rescale()
                owner:Reposition()
                owner:Reanchor()
            end
            UIDropDownMenu_AddButton(info, 2, UIDROPDOWNMENU_MENU_VALUE)
        end
    end
end


local function GetProfiles()
	local copy = CopyTable(DominosDB.profiles)

	return copy
end

local function GetDominos()
	return bar.master.db.profile.frames
end

local frames =  {}

local function GetFrames(settings)
	wipe(frames)
	for id, info in pairs(settings.frames) do
		if bar:IsViable(id) then
			frames[id] = info
		end
	end
	return frames
end

local function FlipHorizontal(layout, looped)
	for key, value in pairs(layout) do
		if not looped then
			if (type(value) == 'table') then
				FlipHorizontal(value, true)
			end
		else
				if (key == 'anchor')then
					if string.find(value, 'Top') then
						layout[key] = string.gsub (value, 'Top', 'Bottom')
					elseif string.find(value, 'Bottom') then
						layout[key] = string.gsub (value, 'Bottom', 'Top')
					end
				end
				 if (key == 'justifyV') then
					if value == 1 then
						layout[key] = 3
					elseif  value == 3 then
						layout[key] = 1
					end
				 end
				if key == 'y' then
					layout[key] = -value					
				end
		end
	end
end

local function FlipVertical(layout, looped)
	for key, value in pairs(layout) do
		if (type(value) == 'table') then
			FlipVertical(value, true)
		else
			if looped then
				if (key == 'anchor')then
					if string.find(value, 'Left') then
						layout[key] = string.gsub (value, 'Left', 'Right')
					elseif string.find(value, 'Right') then
						layout[key] = string.gsub (value, 'Right', 'Left')
					end
				end
				 if (key == 'justifyH') then
					if value == 1 then
						layout[key] = 3
					elseif  value == 3 then
						layout[key] = 1
					end			 end
				if key == 'x' then
					layout[key] = -value					
				end
			end
		end
	end
end

local function AddLayoutPanel(menu)
	local panel = menu:NewPanel(L.Layout)
	panel.opacitySlider = panel:NewOpacitySlider()
	panel.fadeSlider = panel:NewFadeSlider()
	panel.paddingSlider = panel:NewPaddingSlider()
	panel.spacingSlider = panel:NewSpacingSlider()





	panel.scaleSlider = panel:NewScaleSlider()
	return panel
end

local function AddShowState(self)
	local p = self:NewPanel(L.ShowStates)
	p.height = 56
	local editBox = CreateFrame('EditBox', NAME .. 'StateText', p, 'InputBoxTemplate')
	editBox:SetWidth(148) editBox:SetHeight(20)
	editBox:SetPoint('TOPLEFT', 12, -10)
	editBox:SetAutoFocus(false)
	editBox:SetScript('OnShow', function(self)
		self:SetText(self:GetParent().owner:GetShowStates() or '')
	end)
	editBox:SetScript('OnEnterPressed', function(self)
		local text = self:GetText()
		self:GetParent().owner:SetShowStates(text ~= '' and text or nil)
		self:ClearFocus()
	end)
	editBox:SetScript('OnEditFocusLost', function(self) self:HighlightText(0, 0) end)
	editBox:SetScript('OnEditFocusGained', function(self) self:HighlightText() end)
	local set = CreateFrame('Button', NAME .. 'Set', p, 'UIPanelButtonTemplate')
	NAME = NAME + 1
	set:SetWidth(30) set:SetHeight(20)
	set:SetText(L.Set)
	set:SetScript('OnClick', function(self)
		local text = editBox:GetText()
		self:GetParent().owner:SetShowStates(text ~= '' and text or nil)
		editBox:SetText(self:GetParent().owner:GetShowStates() or '')
		editBox:ClearFocus()
	end)
	set:SetPoint('BOTTOMRIGHT', -8, 2)
	return p
end

local function AddAdvancedPanel(menu)
	local panel = menu:NewPanel(L.Advanced)
	panel:NewClickThroughCheckbox()
	panel:NewShowInOverrideUICheckbox()
	panel:NewShowInPetBattleUICheckbox()
	
	local flipVert = bar.Menu.Button(panel, 'Flip Vertical')
	flipVert:SetScript('OnClick', function(self)
		FlipVertical(panel.owner.sets)
		panel.owner:Layout()
	end)

	local flipHori = bar.Menu.Button(panel, 'Flip Horizontal')
	flipHori:SetScript('OnClick', function(self)
		FlipHorizontal(panel.owner.sets)
		panel.owner:Layout()
	end)

	panel:NewSlider({
		name = 'Frame Layer',
		min = 1,
		max = 100,
		get = function(self) --Getter
									self:GetParent().owner.sets.frameLayer = self:GetParent().owner.sets.frameLayer or 4

			return self:GetParent().owner.sets.frameLayer
		end,

		set = function(self) --Setter
							self:GetParent().owner.sets.frameLayer = self:GetParent().owner.sets.frameLayer or 4

			self:GetParent().owner.sets.frameLayer = self:GetValue()
			self:GetParent().owner:Layout()
		end,
	})

	panel:NewSlider({
		name = 'Frame Strata',
		min = 1,
		max = 8,
		get = function(self) --Getter
					self:GetParent().owner.sets.frameStrata = self:GetParent().owner.sets.frameStrata or 4

			return self:GetParent().owner.sets.frameStrata
		end,

		set = function(self) --Setter
					self:GetParent().owner.sets.frameStrata = self:GetParent().owner.sets.frameStrata or 4

			self:GetParent().owner.sets.frameStrata = self:GetValue()
			self:GetParent().owner:Layout()
		end,
	})

	
	local f =  Menu(panel, 'Copy', 'profile')
	f:SetScript('OnShow', function(self)
		if self ~= f then
			return
		end
		f:initialize()
		if not self.stretch then
			self.stretch = 1
			f.button:SetHitRectInsets(0, -(f.title:GetCenter()+ (f.title:GetWidth()/2)- f.button:GetCenter()+ (f.button:GetWidth()/2)), 0, 0)
		end
	end)
	
	function f:initialize(level, ...)
        if level == 1 then
            OnTopMenuShow(panel)
        elseif (level == 2) and UIDROPDOWNMENU_MENU_VALUE then
            OnSubMenuShow(panel, level, ...)
        end
	end

	local b = bar.Menu.Button(panel, 'Delete Frame')
	b:SetScript('OnClick', function(self)
		if not b.clicked then
			b.clicked = true
			b:SetText('Are you sure?')
		else
			bar.master.db.profile.units.frames[panel.owner.id] = nil
			local frames = bar.frames
			if panel.owner then
				panel.owner:Delete()
				panel.owner.frameOverlay:Hide()
			end
			if LibStub and LibStub('LibKeyBound-1.0') then
				LibStub('LibKeyBound-1.0'):Deactivate()
			end
			bar.master:GetModule('ConfigOverlay'):Show()
			bar.menu:Hide()
		end
	end)

	return panel
end

function bar:CreateMenu()
	local menu = bar.master:NewMenu(self.id)
	local panel = AddLayoutPanel(menu)

	if self.components then
		for i, b in pairs(self.components) do
			if b.CreateMenu and bar.Menu then
				b:CreateMenu(menu)
			end
		end
	end

	--AddShowState(menu)
	AddAdvancedPanel(menu)
	return menu
end

local menu, config
function bar:ShowMenu()
	if not bar.master:IsConfigAddonEnabled() then return end
	config = config or LoadAddOn('Dominos_Config')
	L = L or LibStub('AceLocale-3.0'):GetLocale('Dominos-Config')
	bar.menu = bar.menu or self:CreateMenu()

	local menu = bar.menu
	menu:Hide()
	menu:SetOwner(self)
	menu:ShowPanel(L.Layout)
	menu:Show()
end
